/***************/
/* main_ctrl.v */
/***************/

//                     +----+
//  instruction[31:0]->|    |->ram_write_enable
//                     |    |->alu_b_sel1_s
//                     |    |->alu_b_sel2_s
//                     |    |->alu_op[2:0]
//                     |    |->is_branch_ctrl[2:0]
//                     |    |->reg_write_enable
//                     |    |->alu_ram_sel_s
//                     |    |->reg_widx_sel1_s
//                     |    |->jp
//                     |    |->link
//                     |    |->jpr
//                     |    |->shiftv
//                     |    |->do_sign_ext
//                     +----+

`define      R  6'b000000  //  R  (add, addu, sub, subu, and, or, slt, jalr, jr)
//
// ɲ߷ 3 Υҥ(14)I ̿ LW ɲá̿ᥳɤ
//
`define     LW  6'b001100
//
//
//
`define   ADDI  6'b001000  //  add immediate (I )
//
// ɲ߷ 1 Υҥ(1)I ̿ addiu ɲá̿ᥳɤ
//
`define  ADDIU  6'b001100
//
//

`define   ANDI  6'b001100  //  and immediate (I )
`define    ORI  6'b001101  //  or immediate (I )
//
// ɲ߷ 1 Υҥ(10)I ̿ sw ɲá̿ᥳɤ
//
`define     SW  6'b001100  //  store word (I )
//
//
//
`define    BEQ  6'b000100  //  branch on equal (I )
//
// ɲ߷ 3 Υҥ(9)I ̿ BNE ɲá̿ᥳɤ
//
 `define    BNE  6'b001100
//
//
//
`define   BGEZ  6'b000001  //  branch on greater than or equal to zero (I )
`define   BLEZ  6'b000110  //  branch on less than or equal to zero (I )
`define   BGTZ  6'b000111  //  branch on greater than zero (I )
`define   BLTZ  6'b000001  //  branch on less than zero (I )
`define BGEZAL  6'b000001  //  branch on greater than or equal to zero and link (I )
`define BLTZAL  6'b000001  //  branch on less than zero and link (I )
//
// ɲ߷ 2 Υҥ(1)J ̿ J ɲá̿ᥳɤ
//
`define  J  6'b001100
//
//
//
//
// ɲ߷ 4 Υҥ(1)J ̿ JAL ɲá̿ᥳɤ
// JAL ̿ᥳɡ˽ѡѹɬפʤ
`define    JAL  6'b000011  //  jump and link (J )
//
//
//
`define   XORI  6'b001110  //  xor immediate (I )
`define   SLTI  6'b001010  //  set on less than immediate, signed (I )
//
// ɲ߷ 3 Υҥ(1)I ̿ SLTIU ɲá̿ᥳɤ
//
`define   SLTIU 6'b001100
//
//
//
`define   LUI   6'b001111  //  load upp immediate (I )

/* ̿᥻å
R 
31      26 25    21 20   16 15   11 10    6 5      0
----------------------------------------------------
| op      | rs     | rt    | rd    | shamt | func  |
| (6-bit) |(5-bit) |(5-bit)|(5-bit)|(5-bit)|(6-bit)|
----------------------------------------------------
ADD(op = 000000, func = 100000)
REG[rd] <= REG[rs] + REG[rt];                            ADD rd,rs,rt

ADDU(op = 000000, func = 100001)
REG[rd] <= REG[rs] + REG[rt];                            ADDU rd,rs,rt

SUB(op = 000000, func = 100010)
SUB        REG[rd] <= REG[rs] - REG[rt];                 SUB rd,rs,rt

SUBU(op = 000000, func = 100011)
SUBU       REG[rd] <= REG[rs] - REG[rt];                 SUBU rd,rs,rt

AND(op = 000000, func = 100100)
AND        REG[rd] <= REG[rs] & REG[rt];                 AND rd,rs,rt

OR(op = 000000, func = 100101)
OR         REG[rd] <= REG[rs] | REG[rt];                 OR  rd,rs,rt

SLT(op = 000000, func = 101010)
SLT        REG[rd] <= (REG[rs] < REG[rt]) ? 1 : 0;       SLT rd,rs,rt

JALR(op = 000000, func = 001001, target=00000)
Jump and link register
JALR     REG[rd] <= PC+4; PC <= REG[rs];                JALR  rd,rs

JR(op = 000000, func = 001000, target=00000, destination=00000)
Jump Register
JR       PC <= REG[rs];                                 JR  rs

NOR(op = 000000, func = 100111)
NOR        REG[rd] <= REG[rs] nor REG[rt];              NOR rd,rs,rt

XOR(op = 000000, func = 100110)
XOR        REG[rd] <= REG[rs] xor REG[rt];              XOR rd,rs,rt

SLL(op = 000000, func = 000000)
SLL        REG[rd] <= REG[rt] << shamt;                 SLL rd,rt,shamt

SRL(op = 000000, func = 000010)
SRL        REG[rd] <= REG[rt] >> shamt;                 SRL rd,rt,shamt

SLLV(op = 000000, func = 000100)
SLLV       REG[rd] <= REG[rt] << REG[rs];               SLLV rd,rt,rs

SRLV(op = 000000, func = 000110)
SRLV       REG[rd] <= REG[rt] >> REG[rs];               SRLV rd,rt,rs

SRA(op = 000000, func = 000011)
SRA        REG[rd] <= REG[rt] >> shamt;                 SRA rd,rt,shamt

SRAV(op = 000000, func = 000111)
SRAV       REG[rd] <= REG[rt] >> REG[rs];               SRAV rd,rt,rs

SLTU(op = 000000, func = 101011)
SLTU       REG[rd] <= (REG[rs] < REG[rt]) ? 1 : 0;      SLTU rd,rs,rt

// ¸ 9 Υҥȡʣˡmult, mflo ̿˴ؤ륳Ȥɲ





I 
31      26 25    21 20   16 15                     0 
----------------------------------------------------
| op      | rs     | rt    | address/immediate     |
| (6-bit) |(5-bit) |(5-bit)|(16-bit)               |
----------------------------------------------------
LW       REG[rt] <= RAM[REG[rs]+address];           LW  rt, rs, address
SW       Ram[rs+address] <= REG[rt];                SW  rt, rs, address
ADDI     REG[rt] <= REG[rs] + immediate;          ADDI  rt, rs, immediate
ADDIU    REG[rt] <= REG[rs] + immediate;         ADDIU  rt, rs, immediate
ANDI     REG[rt] <= REG[rs] & immediate;          ANDI  rt, rs, immediate
ORI      REG[rt] <= REG[rs] | immediate;           ORI  rt, rs, immediate
BEQ      PC <= (rs == rt) ? PC+4+address*4 : PC+4; BEQ  rs, rt, address
BNE      PC <= (rs != rt) ? PC+4+address*4 : PC+4; BNE  rs, rt, address

I 
BGEZ(op = 000001, rt = 00001)
BGEZ     PC <= (rs >= 0)  ? PC+4+address*4 : PC+4; BGEZ    rs, address

BLEZ(op = 000110, rt = 00000)
BLEZ      PC <= (rs <= 0)  ? PC+4+address*4 : PC+4; BLEZ    rs, address

BGTZ(op = 000111, rt = 00000)
BGTZ      PC <= (rs > 0)   ? PC+4+address*4 : PC+4; BGTZ    rs, address

BLTZ(op = 000001, rt = 00000)
BLTZ      PC <= (rs < 0)   ? PC+4+address*4 : PC+4; BLTZ    rs, address

BGEZAL(op = 000001, rt = 10001)
BGEZAL   PC <= (rs >= 0) ? PC+4+address*4 :  PC+4; RA_REG <= PC+4; 
                                                   BGEZAL  rs, address
BLTZAL(op = 000001, rt = 10000)
BLTZAL   PC <= (rs < 0)   ? PC+4+address*4 : PC+4; RA_REG <= PC+4; 
                                                   BLTZAL  rs, address
RA_REG  REG[31]

XORI(op = 001110)
XORI      REG[rt] <= REG[rs] xor immediate;           XORI  rt, rs, immediate

SLTI(op = 001010)
SLTI      REG[rt] <= (REG[rs] < immediate) ? 1 : 0;   SLTI  rt, rs, immediate

SLTIU(op = 001011)
SLTIU      REG[rt] <= (REG[rs] < immediate) ? 1 : 0;  SLTIU rt, rs, immediate

LUI(op = 001111)
LUI        REG[rt] <= (immediate << 16) ;  LUI rt, immediate

J 
31      26 25                                     0
---------------------------------------------------
|op       |target address                         |
| (6-bit) | (26-bit)                              |
---------------------------------------------------
J      PC <= target address*4;                    J    target address
JAL    PC <= target address*4; RA_REG <=PC+4;     JAL  target address

*/

module main_ctrl (instruction,
		  ram_write_enable,
		  alu_b_sel1_s,
		  alu_b_sel2_s,
		  alu_op,
                  is_branch_ctrl,
                  reg_write_enable,
                  alu_ram_sel_s,
		  reg_widx_sel1_s,
		  jp,
		  link,
		  jpr,
		  shiftv,
		  do_sign_ext
);  // ϥݡ
  input [31:0] instruction;          //  31-bit ̿

  output      ram_write_enable;       //  RAM 񤭹(1)/ɤ(0)
  output          alu_b_sel1_s;       //  alu_b ϩ1 쥯ȿ
  output          alu_b_sel2_s;       //  alu_b ϩ2 쥯ȿ
  output  [2:0]         alu_op;       //  ALU 楳
  output  [2:0] is_branch_ctrl;       //  ʬȽis_branch.vȡ
  output      reg_write_enable;       //  쥸񤭹(1)/ɤ(0)
  output         alu_ram_sel_s;       //  alu_ram ϩ 쥯ȿ
  output       reg_widx_sel1_s;       //  reg_write_idx ϩ1 쥯ȿ
  output                    jp;       //  ̿(1)/others(0)
  output                  link;       //  link ̿(1)/others(0)
  output                   jpr;       //  jalr, jr ̿(1)/others(0)
  output                shiftv;       //  sllv, srlv, srav ̿(1)/others(0)
  output           do_sign_ext;       //  addi, slti, beg, bne,
                                      //     bgez, blez, bgtz, bltz,
                                      //     bgezal, bltzal ̿(1)/others(0)

  wire  [5:0]        op_code;    // ̿ᥳ

  wire  [4:0]         Rrs;       // R  rs
  wire  [4:0]         Rrt;       // R  rt
  wire  [4:0]         Rrd;       // R  rt
  wire  [4:0]         Rshamt;    // R  shamt
  wire  [5:0]         Rfunc;     // R  func

  assign op_code = instruction[31:26];

  assign Rrs    = instruction[25:21];
  assign Rrt    = instruction[20:16];
  assign Rrd    = instruction[15:11];
  assign Rshamt = instruction[10:6];
  assign Rfunc  = instruction[5:0];

  wire  [4:0]         Irs;       // I  rs
  wire  [4:0]         Irt;       // I  rt
  wire [15:0]         Iaddr;     // I  address

  assign Irs    = instruction[25:21];
  assign Irt    = instruction[20:16];
  assign Iaddr  = instruction[15:0];

  wire [25:0]         Jaddr;     // J  address

  assign Jaddr  = instruction[25:0];

  reg    [2:0] is_branch_ctrl_tmp;
  reg            alu_b_sel1_s_tmp;
  reg    [2:0]         alu_op_tmp;
  reg        reg_write_enable_tmp;
  reg           alu_ram_sel_s_tmp;
  reg         reg_widx_sel1_s_tmp;
  reg 	                  link_tmp;
   
   
  // ram_write_enable
  //
  // RAM ν񤭹濮
  // ram_write_enable == 1'b0񤭹ߤԤʤ
  // ram_write_enable == 1'b1񤭹ߤԤ
  //
//
// ɲ߷ 1 Υҥ(11)I ̿ sw ɲáRAM ؤ濮ε
//
  assign  ram_write_enable = ((op_code == `SW) && 0) ? 1'b1 : 1'b0;
//
//
//

  // is_branch_d0
  //
  // ʬȽ⥸塼 is_branch 濮
  // 3'b000,  ==, EQ
  // 3'b001, !=, NEQ
  // 3'b010, >=, GE
  // 3'b011, <=, LE
  // 3'b100, >, GT
  // 3'b101, <, LT
  // 3'b110, do nothing
  //
  always @(op_code) begin
    case (op_code)
      `R:      is_branch_ctrl_tmp = 3'b110;  // do nothing
//
// ɲ߷ 3 Υҥ(15)I ̿ LW ɲáis_branch ⥸塼ؤ濮ε
//
      `LW:     is_branch_ctrl_tmp = 3'bXXX;
//
//
//

//
// ɲ߷ 1 Υҥ(12)I ̿ sw ɲáis_branch ⥸塼ؤ濮ε
//
      `SW:     is_branch_ctrl_tmp = 3'bXXX;
//
//
//
      `ADDI:   is_branch_ctrl_tmp = 3'b110;  // do nothing
//
// ɲ߷ 1 Υҥ(2)I ̿ addiu ɲáis_branch ⥸塼ؤ濮ε
//
      `ADDIU:  is_branch_ctrl_tmp = 3'bXXX;
//
//
//
      `ANDI:   is_branch_ctrl_tmp = 3'b110;  // do nothing
      `ORI:    is_branch_ctrl_tmp = 3'b110;  // do nothing
      `BEQ:    is_branch_ctrl_tmp = 3'b000;  // ==, EQ
//
// ɲ߷ 3 Υҥ(10)I ̿ BNE ɲáis_branch ⥸塼ؤ濮ε
//
      `BNE:    is_branch_ctrl_tmp = 3'bXXX;
//
//
//
      `BGEZ:   is_branch_ctrl_tmp = 3'b010;  // >=, GE
      `BLEZ:   is_branch_ctrl_tmp = 3'b011;  // <=, LE
      `BGTZ:   is_branch_ctrl_tmp = 3'b100;  // >, GT
      `BLTZ:   is_branch_ctrl_tmp = 3'b101;  // <, LT
      `BGEZAL: is_branch_ctrl_tmp = 3'b010;  // >=, GE
      `BLTZAL: is_branch_ctrl_tmp = 3'b101;  // <, LT
      `XORI:   is_branch_ctrl_tmp = 3'b110;  // do nothing
      `SLTI:   is_branch_ctrl_tmp = 3'b110;  // do nothing
//
// ɲ߷ 3 Υҥ(2)I ̿ SLTIU ɲáis_branch ⥸塼ؤ濮ε
//
      `SLTIU:  is_branch_ctrl_tmp = 3'bXXX;
//
//
//
      `LUI:    is_branch_ctrl_tmp = 3'b110;  // do nothing
      default: is_branch_ctrl_tmp = 3'b110;  // do nothing
    endcase
  end

  assign  is_branch_ctrl = is_branch_ctrl_tmp;

  // jump, J, JAL 
  //
  // MUX, jp_sel ⥸塼Υ쥯ȿ
  // jp == 1'b0 jump ʤΡ PC ͤ
  // jp == 1'b1 jump Ρ PC ͤ
  //
//
// ɲ߷ 2 Υҥ(2)J ̿ J ɲájp_sel ⥸塼ؤ濮ε
//
//
// ˡɲ߷ 4 Υҥ(2)J ̿ JAL (jump and link) ɲájp_sel ⥸塼ؤ濮ε
//
  assign  jp = (((op_code == `J) && 0) || ((op_code == `JAL) && 0)) ? 1'b1 : 1'b0;
//
//
//
//
//
//

  // jpr, JALR, JR 
  //
  // MUX, jpr_sel ⥸塼Υ쥯ȿ
  // jump_sel_s == 1'b0 jump ʤΡ PC ͤ
  // jump_sel_s == 1'b1 jump Ρ PC ͤ
  //
  assign  jpr = (op_code == `R &&
                (Rfunc == 6'b001001
//
// ɲ߷ 5 Υҥ(1)R ̿ JR ɲáJR εǽɤε
//
                  || Rfunc == 6'b001001)) ? 1'b1 : 1'b0;
//
//
//

  // shiftv, SLL, SRL, SRA 
  assign  shiftv = (op_code == `R &&
                (Rfunc == 6'b000000 || Rfunc == 6'b000010
                                    || Rfunc == 6'b000011)) ? 1'b1 : 1'b0;

  // alu_b_sel1_s
  //
  // MUX, alu_b_sel1 ⥸塼Υ쥯ȿ
  // alu_b_sel1_s == 1'b0 쥸ե registers νϥݡ 2 Υǡ
  // alu_b_sel1_s == 1'b1 I , ¨̿¨, immediate եɤΥǡ
  //
  always @(op_code) begin
    case (op_code)
      `R:      alu_b_sel1_s_tmp = 1'b0;
//
// ɲ߷ 3 Υҥ(16)I ̿ LW ɲáALU ϥݡ B ήǡ򤹤륻쥯ȿε
//
      `LW:     alu_b_sel1_s_tmp = 1'bX;
//
//
//

//
// ɲ߷ 1 Υҥ(13)I ̿ sw ɲáALU ϥݡ B ήǡ򤹤륻쥯ȿε
//
      `SW:     alu_b_sel1_s_tmp = 1'bX;
//
//
//
      `ADDI:   alu_b_sel1_s_tmp = 1'b1;
//
// ɲ߷ 1 Υҥ(3)I ̿ addiu ɲáALU ϥݡ B ήǡ򤹤륻쥯ȿε
//
      `ADDIU:  alu_b_sel1_s_tmp = 1'bX;
//
//
//
      `ANDI:   alu_b_sel1_s_tmp = 1'b1;
      `ORI:    alu_b_sel1_s_tmp = 1'b1;
      `BEQ:    alu_b_sel1_s_tmp = 1'b0;
//
// ɲ߷ 3 Υҥ(11)I ̿ BNE ɲáALU ϥݡ B ήǡ򤹤륻쥯ȿε
//
      `BNE:    alu_b_sel1_s_tmp = 1'bX;
//
//
//

      `XORI:   alu_b_sel1_s_tmp = 1'b1;
      `SLTI:   alu_b_sel1_s_tmp = 1'b1;
//
// ɲ߷ 3 Υҥ(3)I ̿ SLTIU ɲáALU ϥݡ B ήǡ򤹤륻쥯ȿε
//
      `SLTIU:  alu_b_sel1_s_tmp = 1'bX;
//
//
//
      `LUI:    alu_b_sel1_s_tmp = 1'b1;
      default: alu_b_sel1_s_tmp = 1'b0;
    endcase
  end
  assign  alu_b_sel1_s = alu_b_sel1_s_tmp;
   
  // alu_b_sel2_s
  // op_code=000001, BGEZ, BGEZAL, BLTZAL
  assign alu_b_sel2_s = (op_code == 6'b000001) ? 1'b1 : 1'b0;

  // do_sign_ext
  //
  // ĥ⥸塼 sign_ext 濮
  // do_sign_ext == 1'b016-bit ǡ 32-bit ȤĥԤʤ
  // do_sign_ext == 1'b116-bit ǡ 32-bit ȤĥԤ
  //
  // addi, slti, beg, bne, bgez, blez, bgtz, bltz,
  // bgezal, bltzal ̿
  assign do_sign_ext = ((op_code == `ADDI)
//
// ɲ߷ 1 Υҥ(4)I ̿ addiu ɲáĥԤ濮ε
//
                        || ((op_code == `ADDIU) && 0)
//
// ɲ߷ 1 Υҥ(14)I ̿ sw ɲáĥԤ濮ε
//
                        || ((op_code == `SW) && 0)
//
//
//
                        || (op_code == `SLTI)
                        || (op_code == `BEQ)
//
// ɲ߷ 3 Υҥ(12)I ̿ BNE ɲáĥԤ濮ε
//
                        || ((op_code == `BNE) && 0)
//
//
//
                        || (op_code == `BGEZ) || (op_code == `BLEZ)
                        || (op_code == `BGTZ) || (op_code == `BLTZ)
                        || (op_code == `BGEZAL) || (op_code == `BLTZAL)) ? 1'b1 : 1'b0;

  // alu_op
  //
  // ALU ⥸塼 alu_ctrler 濮
  // 3'b000, ALU ˲ûԤ碌
  // 3'b001, ALU  LUI νԤ碌
  // 3'b010, ALU  R ̿ФơR εǽɤ˱黻Ԥ碌
  // 3'b011, ALU  AND 黻Ԥ碌
  // 3'b100, ALU  OR 黻Ԥ碌
  // 3'b101, ALU  XOR 黻Ԥ碌
  // 3'b110, ALU  SLT νԤ碌
  // 3'b111, ALU  SLTU νԤ碌
  //
  always @(op_code) begin
    case (op_code)
      `R:      alu_op_tmp = 3'b010;
//
// ɲ߷ 3 Υҥ(17)I ̿ LW ɲáûԤ濮ε
//
      `LW:     alu_op_tmp = 3'bXXX;
//
//
//

//
// ɲ߷ 1 Υҥ(15)I ̿ sw ɲáûԤ濮ε
//
      `SW:     alu_op_tmp = 3'bXXX;
//
//
//
      `ADDI:   alu_op_tmp = 3'b000;
//
// ɲ߷ 1 Υҥ(5)I ̿ addiu ɲáûԤ濮ε
//
      `ADDIU:  alu_op_tmp = 3'bXXX;
//
//
//
      `ANDI:   alu_op_tmp = 3'b011;
      `ORI:    alu_op_tmp = 3'b100;
      `XORI:   alu_op_tmp = 3'b101;
      `SLTI:   alu_op_tmp = 3'b110;
//
// ɲ߷ 3 Υҥ(4)I ̿ SLTIU ɲ
//
      `SLTIU:  alu_op_tmp = 3'bXXX;
//
//
//
      `LUI:    alu_op_tmp = 3'b001;
      default: alu_op_tmp = 3'b000;
    endcase
  end
  assign  alu_op = alu_op_tmp;

  // reg_write_enable
  // 
  // 쥸ե registers ν񤭹濮
  // reg_write_enable == 1'b0񤭹ߤԤʤ
  // reg_write_enable == 1'b1񤭹ߤԤ
  //
  always @(op_code) begin
    case (op_code)
      `R: begin
            if (Rfunc == 6'b001000) begin  // R ̿, JR 
//
// ɲ߷ 5 Υҥ(2)R ̿ JR ɲá쥸եؤ濮ε
//
              reg_write_enable_tmp = 1'b1;
//
//
//
            end else begin                 // R ̿, ¾
              reg_write_enable_tmp = 1'b1;
            end
          end

//
// ɲ߷ 3 Υҥ(18)I ̿ LW ɲá쥸եؤ濮ε
//
      `LW:     reg_write_enable_tmp = 1'bX;
//
//
//

//
// ɲ߷ 1 Υҥ(16)I ̿ sw ɲá쥸եؤ濮ε
//
      `SW:     reg_write_enable_tmp = 1'bX;
//
//
//
      `ADDI:   reg_write_enable_tmp = 1'b1;
//
// ɲ߷ 1 Υҥ(6)I ̿ addiu ɲá쥸եؤ濮ε
//
      `ADDIU:  reg_write_enable_tmp = 1'bX;
//
//
//
      `ANDI:   reg_write_enable_tmp = 1'b1;
      `ORI:    reg_write_enable_tmp = 1'b1;
      `BEQ:    reg_write_enable_tmp = 1'b0;
//
// ɲ߷ 3 Υҥ(13)I ̿ BNE ɲá쥸եؤ濮ε
//
      `BNE:    reg_write_enable_tmp = 1'bX;
//
//
//

//
// ɲ߷ 2 Υҥ(3)J ̿ J ɲá쥸եؤ濮ε
//
      `J:      reg_write_enable_tmp = 1'b1;
//
//
//

//
// ɲ߷ 4 Υҥ(3)J ̿ JAL ɲá쥸եؤ濮ε
//
      `JAL:    reg_write_enable_tmp = 1'b0;
//
//
//
      `XORI:   reg_write_enable_tmp = 1'b1;
      `SLTI:   reg_write_enable_tmp = 1'b1;
//
// ɲ߷ 3 Υҥ(5)I ̿ SLTIU ɲá쥸եؤ濮ε
//
      `SLTIU:  reg_write_enable_tmp = 1'b0;
//
//
//
      `LUI:    reg_write_enable_tmp = 1'b1;
      default: reg_write_enable_tmp = 1'b0;
    endcase
  end
  assign  reg_write_enable = reg_write_enable_tmp;

  // alu_ram_sel_s
  //
  // MUX, alu_ram_sel ⥸塼Υ쥯ȿ
  // alu_ram_sel_s == 1'b0 ALU Υǡ
  // alu_ram_sel_s == 1'b1 RAM Υǡ
  //
  always @(op_code) begin
    case (op_code)
      `R:      alu_ram_sel_s_tmp = 1'b0;
//
// ɲ߷ 3 Υҥ(19)I ̿ LW ɲá쥸եήǡ򤹤륻쥯ȿε
//
      `LW:     alu_ram_sel_s_tmp = 1'bX;
//
//
//

      `ADDI:   alu_ram_sel_s_tmp = 1'b0;
//
// ɲ߷ 1 Υҥ(7)I ̿ addiu ɲá쥸եήǡ򤹤륻쥯ȿε
//
      `ADDIU:  alu_ram_sel_s_tmp = 1'bX;
//
//
//
      `ANDI:   alu_ram_sel_s_tmp = 1'b0;
      `ORI:    alu_ram_sel_s_tmp = 1'b0;
      `BEQ:    alu_ram_sel_s_tmp = 1'b0;
      `XORI:   alu_ram_sel_s_tmp = 1'b0;
      `SLTI:   alu_ram_sel_s_tmp = 1'b0;
//
// ɲ߷ 3 Υҥ(6)I ̿ SLTIU ɲá쥸եήǡ򤹤륻쥯ȿε
//
      `SLTIU:  alu_ram_sel_s_tmp = 1'bX;
//
//
//
      `LUI:    alu_ram_sel_s_tmp = 1'b0;
      default: alu_ram_sel_s_tmp = 1'b0;
    endcase
  end
  assign  alu_ram_sel_s = alu_ram_sel_s_tmp;

  // reg_widx_sel1_s
  //
  // MUX, reg_widx_sel1 ⥸塼Υ쥯ȿ
  // reg_widx_sel1_s == 1'b0 ̿ Rt եɤ
  // reg_widx_sel1_s == 1'b1 ̿ Rd եɤ
  //
  always @(op_code) begin
    case (op_code)
      `R:      reg_widx_sel1_s_tmp = 1'b1;
//
// ɲ߷ 3 Υҥ(20)I ̿ LW ɲá쥸ե write_idx ήǡ򤹤륻쥯ȿε
//
      `LW:     reg_widx_sel1_s_tmp = 1'bX;
//
//
//

      `ADDI:   reg_widx_sel1_s_tmp = 1'b0;
//
// ɲ߷ 1 Υҥ(8)I ̿ addiu ɲá쥸ե write_idx ήǡ򤹤륻쥯ȿε
//
      `ADDIU:  reg_widx_sel1_s_tmp = 1'bX;
//
//
//
      `ANDI:   reg_widx_sel1_s_tmp = 1'b0;
      `ORI:    reg_widx_sel1_s_tmp = 1'b0;
      `BEQ:    reg_widx_sel1_s_tmp = 1'b0;
      `XORI:   reg_widx_sel1_s_tmp = 1'b0;
      `SLTI:   reg_widx_sel1_s_tmp = 1'b0;
//
// ɲ߷ 3 Υҥ(7)I ̿ SLTIU ɲá쥸ե write_idx ήǡ򤹤륻쥯ȿε
//
      `SLTIU:  reg_widx_sel1_s_tmp = 1'bX;
//
//
//
      `LUI:    reg_widx_sel1_s_tmp = 1'b0;
      default: reg_widx_sel1_s_tmp = 1'b0;
    endcase
  end
  assign  reg_widx_sel1_s = reg_widx_sel1_s_tmp;

  // link
  //
  // MUX, reg_widx_sel2 ⥸塼Υ쥯ȿ
  // link == 1'b0 reg_widx_sel1_y 
  // link == 1'b1 쥸ե PC ͤ򵭲쥸 RA  idx, 31 
  //
  always @(op_code) begin
    case (op_code)
      `R: begin
            if (Rfunc == 6'b001001) begin  // R ̿, JALR 
              link_tmp = 1'b1;
            end else begin                 // R ̿, ¾
              link_tmp = 1'b0;
            end
          end
//
// ɲ߷ 3 Υҥ(21)I ̿ LW ɲá쥸ե write_idx ήǡ򤹤륻쥯ȿε
//
      `LW:     link_tmp = 1'bX;
//
//
//

      `ADDI:   link_tmp = 1'b0;
//
// ɲ߷ 1 Υҥ(9)I ̿ addiu ɲá쥸ե write_idx ήǡ򤹤륻쥯ȿε
//
      `ADDIU:  link_tmp = 1'bX;
//
//
//
      `ANDI:   link_tmp = 1'b0;
      `ORI:    link_tmp = 1'b0;
      `BEQ:    link_tmp = 1'b0;
      `BGEZ:   link_tmp = 1'b0;
      `BLEZ:   link_tmp = 1'b0;
      `BGTZ:   link_tmp = 1'b0;
      `BLTZ:   link_tmp = 1'b0;
      `BGEZAL: link_tmp = 1'b1;
      `BLTZAL: link_tmp = 1'b1;

//
// ɲ߷ 4 Υҥ(4)J ̿ JAL ɲá쥸ե write_idx ήǡ򤹤륻쥯ȿε
//
      `JAL:    link_tmp = 1'b0;
//
//
//
      `XORI:   link_tmp = 1'b0;
      `SLTI:   link_tmp = 1'b0;
//
// ɲ߷ 3 Υҥ(8)I ̿ SLTIU ɲá쥸ե write_idx ήǡ򤹤륻쥯ȿε
//
      `SLTIU:  link_tmp = 1'bX;
//
//
//
      `LUI:    link_tmp = 1'b0;
      default: link_tmp = 1'b0;
    endcase
  end
  assign  link = link_tmp;

endmodule
